from blinker import Signal, signal

DMS_KLINE = "kline"
DMS_PRICE = "price"
DMS_LOB = "lob"
DMS_BBO = "bbo"
DMS_TRADE = "trade"

OMS_ORDER_UPDATE = "oms_order"

EVENT_SUB_NAME = "sub"
EVENT_UNSUB_NAME = "unsub"

REDIS_SUB = "redis_sub"

## signal

# 全局信号
GLOBAL_SIGNAL = Signal()

DMS_SIGNAL = signal("dms")
OMS_SIGNAL = signal("oms")

DMS_BBO_SIGNAL = signal(DMS_BBO)
DMS_LOB_SIGNAL = signal(DMS_LOB)
DMS_TRADE_SIGNAL = signal(DMS_TRADE)
DMS_KLINE_SIGNAL = signal(DMS_KLINE)
DMS_PRICE_SIGNAL = signal(DMS_PRICE)

OMS_ORDER_UPDATE_SIGNAL = signal(OMS_ORDER_UPDATE)

DMS_SIGNAL_MAP = {
    DMS_BBO: DMS_BBO_SIGNAL,
    DMS_LOB: DMS_LOB_SIGNAL,
    DMS_TRADE: DMS_TRADE_SIGNAL,
    DMS_KLINE: DMS_KLINE_SIGNAL,
    DMS_PRICE: DMS_PRICE_SIGNAL,
}

OMS_SIGNAL_MAP = {
    OMS_ORDER_UPDATE: OMS_ORDER_UPDATE_SIGNAL,
}

REDIS_SIGNAL_MAP = {
    REDIS_SUB: REDIS_SUB,
}

POSITION_SIDE_UNSPECIFIED = 0
POSITION_SIDE_LONG = 1  # 做多
POSITION_SIDE_SHORT = 2  # 做空
POSITION_SIDE_NOTBOTH = 3  # 单向持仓
POSITION_SIDE_BOTH = 4  # 双向持仓


EXCHANGE_UNSPECIFIED = 0
EXCHANGE_BINANCE = 1
EXCHANGE_OKEX = 2
EXCHANGE_COINBASE = 3

SECURITY_TYPE_UNSPECIFIED = 0
SECURITY_TYPE_SPOT = 1
SECURITY_TYPE_PERP = 2  # 永续合约
SECURITY_TYPE_FUTURE = 3  # 交割
SECURITY_TYPE_OPTION = 4  # 期权

CONTRACT_TYPE_UNSPECIFIED = 0
CONTRACT_TYPE_INVERSE = 1  # 反向合约,币本位合约
CONTRACT_TYPE_LINEAR = 2  # 正向合约,u本位合约

ORDER_TYPE_UNSPECIFIED = 0
ORDER_TYPE_MARKET = 1
ORDER_TYPE_LIMIT = 2
ORDER_TYPE_STOP_MARKET = 3
ORDER_TYPE_STOP_LIMIT = 4

ORDER_DIRECTION_UNSPECIFIED = 0
ORDER_DIRECTION_BUY = 1  # 买入
ORDER_DIRECTION_SELL = 2  # 卖出

ORDER_DIRECTION_BUY_STR = "ORDER_DIRECTION_BUY"
ORDER_DIRECTION_SELL_STR = "ORDER_DIRECTION_SELL"

ORDER_DIRECTION_MAP = {
    ORDER_DIRECTION_BUY: ORDER_DIRECTION_BUY_STR,
    ORDER_DIRECTION_SELL: ORDER_DIRECTION_SELL_STR
}

POSITION_SIDE_UNSPECIFIED_STR = "POSITION_SIDE_UNSPECIFIED"
POSITION_SIDE_BOTH_STR = "POSITION_SIDE_BOTH"
POSITION_SIDE_NOTBOTH_STR = "POSITION_SIDE_NOTBOTH"
POSITION_SIDE_SHORT_STR = "POSITION_SIDE_SHORT"
POSITION_SIDE_LONG_STR = "POSITION_SIDE_LONG"


POSITION_SIDE_MAP = {
    POSITION_SIDE_UNSPECIFIED: POSITION_SIDE_UNSPECIFIED_STR,
    POSITION_SIDE_LONG: POSITION_SIDE_LONG_STR,
    POSITION_SIDE_SHORT: POSITION_SIDE_SHORT_STR,
    POSITION_SIDE_NOTBOTH: POSITION_SIDE_NOTBOTH,
    POSITION_SIDE_BOTH: POSITION_SIDE_BOTH
}

TIME_IN_FORCE_UNSPECIFIED = 0
TIME_IN_FORCE_GTC = 1  # Good Till Cancel
TIME_IN_FORCE_IOC = 2  # Immediate Or Cancel
TIME_IN_FORCE_FOK = 3  # Fill Or Kill
TIME_IN_FORCE_GTX = 4  # Good Till Crossing

ORDER_STATUS_OMS_CREATED = "ORDER_STATUS_OMS_CREATED"
ORDER_STATUS_OMS_PLACE_ORDER_FAILED = "ORDER_STATUS_OMS_PLACE_ORDER_FAILED"
ORDER_STATUS_NEW = "ORDER_STATUS_NEW"
ORDER_STATUS_PARTIALLY_FILLED = "ORDER_STATUS_PARTIALLY_FILLED"
ORDER_STATUS_FILLED = "ORDER_STATUS_FILLED"
ORDER_STATUS_CANCELED = "ORDER_STATUS_CANCELED"
ORDER_STATUS_REJECTED = "ORDER_STATUS_REJECTED"
ORDER_STATUS_EXPIRED = "ORDER_STATUS_EXPIRED"

STRING_SECURITY_TYPE_SPOT = "SECURITY_TYPE_SPOT"
STRING_SECURITY_TYPE_PERP = "SECURITY_TYPE_PERP"
STRING_SECURITY_TYPE_FUTURE = "SECURITY_TYPE_FUTURE"


HEDGING_MODE_UNSPECIFIED = 0
HEDGING_MODE_ON = 1
HEDGING_MODE_DOWN = 2